Attribute VB_Name = "Module1"
'*******************************************************************
'*                                                                 *
'*                         DiskSims 1.0 Beta                       *
'*                    A Disk Schduling Simulator                   *
'*       Released under the GPL (GNU General Public Licence)       *
'*                                                                 *
'*               Copyright (c) 2004-2007 Ammar Muqaddas            *
'*                        ammar@solostuff.net                      *
'*                        ammar.mu@gmail.com                       *
'*                         www.solostuff.net                       *
'*                                                                 *
'*******************************************************************


'  To Add a new parameter to the simulation page, do the following (in sequence):
'  1. Increase the Coption(LAST_PARAM).index to Coption(LAST_PARAM).index+1
'  2. Increase LAST_PARAM by one, and increase FILE_VERSION by 1 (or whatever you want)
'  3. Add new controls (cparam, cm,PCheck,COption,UpDown) with indexes=LAST_PARAM
'  4. Modify the nested loops in Startb_Click() and in GetTableRow(...) by adding an extra for loop for the new parameter. You should modify the loops code to take care of the new parameter
'  5. Change OpenS_Click to include default values for the new parameter. (Param2(LAST_PARAM).start, Param2(LAST_PARAM).step, Param2(LAST_PARAM).LAST, Savep_cont.Item(LAST_PARAM))
'  6. You might need to modify Cparam_Change()
'
'  7. Thats all!! The rest of the program is general and will handle the changes automatically

Public Type Range
    start As Double
    step As Double
    last As Double
End Type

Public Type DiskProp
    cylinders As Long
    blocks_per_track As Long
    heads As Long
    L_cylinders As Long
    L_blocks_per_track As Long
    L_heads As Long
    fullseek As Double
    avseek As Double
    tttseek As Double
    rotspeed As Double
    bytes_per_block As Long
    avlatency As Double
    buffer As Double
End Type

Public pathslash As String          ' Contains the exe path + "\" at the end
Public rcount As Long                      ' Number of rows (last dimention) in avwait and seekt
Public avwait() As Double, seekt() As Double
Public Const FCFS As Integer = 1, SSTF As Integer = 2, SCAN As Integer = 3, CSCAN As Integer = 4, LOOK As Integer = 5, CLOOK As Integer = 6, SLOOK As Integer = 7, BOPATH As Integer = 8, last As Integer = 8
Public AlgNames(1 To last) As String
Public noupdate As Boolean
Public fc() As FCopy, fcsize As Integer
Public Const LAST_PARAM As Integer = 12, FILE_VERSION As Integer = 1
Public Param(LAST_PARAM) As Range
Public Param2(LAST_PARAM) As Range
Public currentp As DiskProp
Public diskar() As DiskProp

'Win API
Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Type msg
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type

Public Const WM_APP = &H8000&
Public Const WM_PROGRESS = WM_APP + 1
Public Const WM_STOP = WM_APP + 2
Public Const WM_THREADID = WM_APP + 3
Public Const PM_REMOVE = &H1

Public Const SYNCHRONIZE = &H100000
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const PROCESS_ALL_ACCESS = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF

' For MsgWaitForMultipleObjects
Public Const INFINITE = &HFFFF      '  Infinite timeout
Public Const QS_SENDMESSAGE = &H40
Public Const QS_PAINT = &H20
Public Const QS_TIMER = &H10
Public Const QS_POSTMESSAGE = &H8
Public Const QS_MOUSEBUTTON = &H4
Public Const QS_MOUSEMOVE = &H2
Public Const QS_HOTKEY = &H80
Public Const QS_KEY = &H1
Public Const QS_ALLINPUT = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)


Public Declare Function GetProcessVersion Lib "kernel32" (ByVal ProcessID As Long) As Long
Public Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long
Public Declare Function MsgWaitForMultipleObjects Lib "user32" (ByVal nCount As Long, pHandles As Long, ByVal fWaitAll As Long, ByVal dwMilliseconds As Long, ByVal dwWakeMask As Long) As Long
Public Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function PostThreadMessage Lib "user32" Alias "PostThreadMessageA" (ByVal idThread As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Function BestUnitSymbol(ByVal v As Double, ByVal llim As Double, ByVal ulim As Double) As String
'While v > 100 Or v < 0.001
'   If v > 100 Then v = v / 1000 Else v = v * 1000
'Wend
Dim log10 As Double
log10 = Log(10)
If v = 0 Then BestUnitSymbol = CStr(v): Exit Function
If v > ulim Then
   a& = Fix(Log(v / ulim) / (log10 * 3)) + 1
   v = v / (10 ^ (3 * a&))
   If a& <= 3 Then
      BestUnitSymbol = v & Choose(a&, " K", " M", " G")
   Else: BestUnitSymbol = v & "e+" & (a& * 3) & " "
   End If
ElseIf v < llim Then
   a& = Fix(Log(llim / v) / (log10 * 3)) + 1
   v = v * (10 ^ (3 * a&))
   If a& <= 3 Then
      BestUnitSymbol = v & Choose(a&, " m", " ", " n")
   Else: BestUnitSymbol = v & "e-" & (a& * 3) & " "
   End If
Else: BestUnitSymbol = CStr(v) & " "
End If
End Function

Public Function DMod(ByVal a As Double, ByVal b As Double) As Double
   DMod = a - b * Fix(a / b)
End Function




Public Function dgcd(ByVal a As Double, ByVal b As Double) As Double
#If APM Then
' Calculates the GCD of two double numbers.
' Simple Idea, but took me days to accuratly complete it. All because of inaccuracies in VB Double precision

Dim r1 As Double
Dim h1 As HugeInt, h2 As HugeInt, h3 As HugeInt

' a and b should be positive
If a <= 0 Or b <= 0 Then dgcd = -1: Exit Function

' Integerize a,b
a1% = 0
While a > Fix(a) Or b > Fix(b)
   a = a * 10: b = b * 10: a1% = a1% + 1
Wend

' Caculate GCD using APM library
h1 = DecToHugeInt(Format(a, "#")): h2 = DecToHugeInt(Format(b, "#"))
h3 = GCD(h1, h2): r1 = CDbl(HugeIntToDecString(h3))
Erase h1.Digits: Erase h2.Digits: Erase h3.Digits

' Euclids Algorithm for GCD
'If a < b Then r3 = Val(a): r2 = Val(b) Else r2 = Val(a): r3 = Val(b)
'Do
'   r1 = r2: r2 = r3
'   ' Getting the Modulo
'   r3 = r1 - r2 * Fix(r1 / r2)
'   r3 = r1 Mod r2
'Loop While r3 <> 0

' Checking for presission failure
'r3 = Val(a / r2): If r3 > Fix(r3) Then dgcd = -1: Exit Function
'r3 = Val(b / r2): If r3 > Fix(r3) Then dgcd = -1: Exit Function

dgcd = r1 * (10 ^ -a1%)
#Else
dgcd = -1
#End If
End Function

Public Function Integerize(ParamArray ar()) As Long
' Muliplies all variables given to it by 10 until all of them become integers
' The number of times the multiplication is done is returned

Dim flag As Boolean

a1& = 0
Do
   flag = False
   For n% = LBound(ar) To UBound(ar)
      flag = flag Or ar(n%) > Fix(ar(n%))
   Next n%
   If flag Then
      For n% = LBound(ar) To UBound(ar)
         ar(n%) = Val(ar(n%) * 10)
      Next n%
      a1& = a1& + 1
   End If
Loop While flag
Integerize = a1&
End Function

#If APM Then
Public Function RoundDiv(Numerator As HugeInt, Denominator As HugeInt) As HugeInt
Dim h1 As HugeInt, h2 As HugeInt, h3 As HugeInt

   h1 = IntOut(2): h3 = Divide(Denominator, h1): Erase h1.Digits
   DivMod Numerator, Denominator, RoundDiv, h2
   If IsGreater(h2, h3) Then
      Erase h2.Digits: Erase h3.Digits
      h3 = One(): h2 = Add(RoundDiv, h3)
      Erase RoundDiv.Digits: RoundDiv = h2
   End If
   Erase h2.Digits: Erase h3.Digits
End Function
#End If

Function StrDiv10(str As String, pow As Long) As String
   a& = Len(str)
   If pow = 0 Then StrDiv10 = str: Exit Function
   
   If a& > pow Then
      StrDiv10 = Left(str, a& - pow) & "."
   Else
      StrDiv10 = "0." & String(pow - a&, 48)
   End If
   StrDiv10 = StrDiv10 & Right(str, pow)
End Function

Sub UpdateCurrentp()
currentp.cylinders = Val(FDiskProp.Dparam(0))
currentp.blocks_per_track = Val(FDiskProp.Dparam(1))
currentp.heads = Val(FDiskProp.Dparam(2))
currentp.L_cylinders = Val(FDiskProp.Dparam(3))
currentp.L_blocks_per_track = Val(FDiskProp.Dparam(4))
currentp.L_heads = Val(FDiskProp.Dparam(5))
currentp.fullseek = Val(FDiskProp.Dparam(6))
currentp.avseek = Val(FDiskProp.Dparam(7))
currentp.tttseek = Val(FDiskProp.Dparam(8))
currentp.rotspeed = Val(FDiskProp.Dparam(9))
currentp.avlatency = Val(FDiskProp.Dparam(10))
currentp.bytes_per_block = Val(FDiskProp.Dparam(11))
currentp.buffer = Val(FDiskProp.Dparam(12))
End Sub

Sub UpdateFDP(DP As DiskProp)
' Updates FDiskProp with DP values
FDiskProp.Dparam(0) = DP.cylinders
FDiskProp.Dparam(1) = DP.blocks_per_track
FDiskProp.Dparam(2) = DP.heads
FDiskProp.Dparam(3) = DP.L_cylinders
FDiskProp.Dparam(4) = DP.L_blocks_per_track
FDiskProp.Dparam(5) = DP.L_heads
FDiskProp.Dparam(6) = DP.fullseek
FDiskProp.Dparam(7) = DP.avseek
FDiskProp.Dparam(8) = DP.tttseek
FDiskProp.Dparam(9) = DP.rotspeed
FDiskProp.Dparam(10) = DP.avlatency
FDiskProp.Dparam(11) = DP.bytes_per_block
FDiskProp.Dparam(12) = DP.buffer
End Sub

Function GetFileName(ByVal a As String) As String
  n% = Len(a)
  While Mid$(a, n%, 1) <> "\" And n% > 1
    n% = n% - 1
  Wend
  If Mid$(a, n%, 1) = "\" Then n% = n% + 1
  GetFileName = Mid$(a, n%)
End Function

Sub CentreForm(f As Form)
   f.Move (Screen.Width - f.Width) / 2, (Screen.Height - f.Height) / 2
End Sub


Sub CopyChart(Schart As MSChart, Dchart As MSChart)
   Dchart.ShowLegend = Schart.ShowLegend
   Dchart.chartType = Schart.chartType
   Dchart.Title = Schart.Title: Dchart.FootnoteText = Schart.FootnoteText
   Dchart.RowCount = Schart.RowCount: Dchart.ColumnCount = Schart.ColumnCount
   Dchart.RowLabelCount = Schart.RowLabelCount
   a1% = Schart.RowLabelIndex: Dchart.RowLabelIndex = 2: Dchart.row = 1: Schart.RowLabelIndex = 2: Schart.row = 1
   Dchart.RowLabel = Schart.RowLabel: Dchart.RowLabelIndex = 1: Schart.RowLabelIndex = a1%
   For n% = 1 To Schart.ColumnCount
      Dchart.column = n%: Schart.column = n%: Dchart.ColumnLabel = Schart.ColumnLabel
   Next n%
   For n% = 1 To Schart.RowCount
      Dchart.row = n%: Schart.row = n%: Dchart.RowLabel = Schart.RowLabel
      For n1% = 1 To Schart.ColumnCount
         Dchart.column = n1%: Schart.column = n1%: Dchart.Data = Schart.Data
      Next n1%
   Next n%
End Sub



Sub GetRange(text As String, rng As Range)
   rng.start = Val(text)
   a1% = InStr(1, text, ",", vbBinaryCompare)
   a2% = InStr(a1% + 1, text, ",", vbBinaryCompare)
   If a1% > 0 And a2% > 0 Then
      rng.step = Val(Mid$(text, a1% + 1))
      rng.last = Val(Mid$(text, a2% + 1))
      If rng.step = 0 Then rng.step = IIf(rng.last < rng.start, -1, 1)
   Else
      rng.step = 1: rng.last = rng.start
   End If
End Sub

Function max(a As Integer, b As Integer) As Integer
   max = IIf(a > b, a, b)
End Function

Function CentreFormX(f As Form) As Long
  CentreFormX = (Screen.Width - f.Width) / 2
End Function

Function CentreFormY(f As Form) As Long
  CentreFormY = (Screen.Height - f.Height) / 2
End Function
Function min(a As Integer, b As Integer) As Integer
   min = IIf(a < b, a, b)
End Function
Function mind(a As Double, b As Double) As Double
   mind = IIf(a < b, a, b)
End Function
Function maxd(a As Double, b As Double) As Double
   maxd = IIf(a > b, a, b)
End Function
Function onlynumeric(ByVal text As String, ByVal alow_sign As Boolean, ByVal alow_point As Boolean, ByVal alow_e, ByVal unit As String) As String
   Dim pflag As Boolean, sflag As Boolean, esflag As Boolean, eflag As Boolean
   b$ = "": pflag = False: sflag = True: eflag = False: esflag = False
   For n% = 1 To Len(text)
      b1$ = Mid$(text, n%, 1)
      If (Asc(b1$) >= 48 And Asc(b1$) <= 57) Or (alow_point And b1$ = "." And Not pflag) Or b1$ = "," Or (sflag And alow_sign And b1$ = "-") Or (esflag And b1$ = "-") Or (alow_e And (b1$ = "e" Or b1$ = "E") And Not eflag) Then b$ = b$ & b1$: sflag = (b1$ = ","): esflag = (b1$ = "e" Or b1$ = "E")
      pflag = (pflag Or (b1$ = ".")) And b1$ <> ","
      eflag = (eflag Or b1$ = "e" Or b1$ = "E") And b1$ <> ","
   Next n%
   onlynumeric = b$ & unit
End Function

Sub ReplaceString(text As String, rstring As String, bystring As String)
If rstring = "" Or text = "" Then Exit Sub
a1& = Len(rstring): a2& = Len(bystring)
a& = InStr(1, text, rstring, vbBinaryCompare)
While a& <> 0
   text = Left$(text, a& - 1) & bystring & Mid$(text, a& + a1&)
   a& = InStr(a& + a2&, text, rstring, vbBinaryCompare)
Wend
End Sub

